=== debian/changelog ===
mcrl2 (201210.1-1ubuntu1) raring; urgency=low

  * Fix FTBFS on arm*: Disable GUI tools on arm* as they require
    QtOpenGL (GLES) and GL in the same binary.

 -- Felix Geyer <debfx@ubuntu.com>  Mon, 05 Nov 2012 13:50:03 +0100

mcrl2 (201210.1-1) unstable; urgency=low

  [ Jeroen Keiren ]
  * New upstream (bugfix) release.

 -- Jeroen Keiren <jkeiren@win.tue.nl>  Fri, 26 Oct 2012 07:50:49 +0200
